/**************************************************************************

   Fotoxx      edit photos and manage collections

   Copyright 2007 2008 2009 2010 2011 2012 2013 Michael Cornelison
   Source URL: http://kornelix.com/fotoxx
   Contact: kornelix@gmx.de
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program. If not, see http://www.gnu.org/licenses/.

***************************************************************************/

#define EX extern                                                          //  enable extern declarations
#include "fotoxx.h"


void build_menus()                                                         //  v.13.01
{
   //  build the main window menus, either classic (at the top of the window)
   //   or vertical on the left side of the window.

   GtkWidget   *mFile, *mTools, *mMeta, *mArea;
   GtkWidget   *mImage, *mRet, *mRep, *mColor, *mBend, *mEff, *mComb;
   GtkWidget   *mPlug, *mHelp;
   GtkWidget   *fhbox, *fvb1, *fvb2;
   GtkWidget   *KBshort = (GtkWidget *) -1;                                //  KB shortcuts not in menu or toolbar   v.13.04
   Vmenu       *fvbm = 0;

   if (strEqu(menu_style,"classic"))                                       //  classic menu and toolbar
   {
      fMenu = create_menubar(fVbox);                                       //  add menu bar to main window
      fTbar = create_toolbar(fVbox);                                       //  add toolbar
      fDwin = gtk_drawing_area_new();                                      //  add drawing window
      gtk_box_pack_start(GTK_BOX(fVbox),fDwin,1,1,0);
      fSbar = create_stbar(fVbox);                                         //  add status bar

      if (strEqu(tbar_style,"icons"))                                      //  set toolbar style
         gtk_toolbar_set_style(GTK_TOOLBAR(fTbar),GTK_TOOLBAR_ICONS);
      else if (strEqu(tbar_style,"text"))
         gtk_toolbar_set_style(GTK_TOOLBAR(fTbar),GTK_TOOLBAR_TEXT);
      else gtk_toolbar_set_style(GTK_TOOLBAR(fTbar),GTK_TOOLBAR_BOTH);

      mFile = add_menubar_item(fMenu,ZTX("File"),topmenufunc);             //  add top menu items
      mTools = add_menubar_item(fMenu,ZTX("Tools"),topmenufunc);
      mMeta = add_menubar_item(fMenu,ZTX("Metadata"),topmenufunc);
      mArea = add_menubar_item(fMenu,ZTX("Areas"),topmenufunc);
      mImage = add_menubar_item(fMenu,ZTX("Image"),topmenufunc);
      mRet = add_menubar_item(fMenu,ZTX("Retouch"),topmenufunc);
      mRep = add_menubar_item(fMenu,ZTX("Repair"),topmenufunc);
      mColor = add_menubar_item(fMenu,ZTX("Color"),topmenufunc);
      mBend = add_menubar_item(fMenu,ZTX("Bend"),topmenufunc);
      mEff = add_menubar_item(fMenu,ZTX("Effects"),topmenufunc);
      mComb = add_menubar_item(fMenu,ZTX("Combine"),topmenufunc);
      mPlug = add_menubar_item(fMenu,ZTX("Plugins"),topmenufunc);
      mHelp = add_menubar_item(fMenu,ZTX("Help"),topmenufunc);
   }
   
   else                                                                    //  vertical menu and toolbar
   {
      fhbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL,0);                   //   ____________________
      gtk_box_pack_start(GTK_BOX(fVbox),fhbox,1,1,0);                      //  |       |            |
      fvb1 = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                      //  | fvb1  | fvb2       | fhbox
      fvb2 = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                      //  | menu  | image      |
      gtk_box_pack_start(GTK_BOX(fhbox),fvb1,0,0,0);                       //  |_______|____________|
      gtk_box_pack_start(GTK_BOX(fhbox),fvb2,1,1,0);                       //  |____________________| status bar
      fDwin = gtk_drawing_area_new();
      gtk_box_pack_start(GTK_BOX(fvb2),fDwin,1,1,0);
      fSbar = create_stbar(fVbox);
      gtk_widget_set_size_request(fvb1,10,10);                             //  compensate GTK bug
      fvbm = Vmenu_new(fvb1);
      fVMenu = fvb1;                                                       //  global name for win_fullscreen()      v.13.03

      mFile = create_popmenu();                                            //  add top menu items to menu vbox
      mTools = create_popmenu();
      mMeta = create_popmenu();
      mArea = create_popmenu();
      mImage = create_popmenu();
      mRet = create_popmenu();
      mRep = create_popmenu();
      mColor = create_popmenu();
      mBend = create_popmenu();
      mEff = create_popmenu();
      mComb = create_popmenu();
      mHelp = create_popmenu();
      mPlug = create_popmenu();
      fTbar = 0;                                                           //  no GTK toolbar
      
      cchar * favorites_tip = ZTX("Favorites Menu");
      cchar * file_tip = ZTX("Open, Save, Trash, Rename, Print");
      cchar * tools_tip = ZTX("Synch Files, Settings, Collections, Batch Funcs ...");
      cchar * metadata_tip = ZTX("Captions, Tags, Ratings, Geotags, Search ... ");
      cchar * areas_tip = ZTX("Select image areas to edit, copy and paste");
      cchar * image_tip = ZTX("Rotate, Trim/Crop, Resize, Add Text");
      cchar * retouch_tip = ZTX("Improve brightness, contrast, color ...");
      cchar * repair_tip = ZTX("Sharpen, Clean, Red-eyes, Paint, Clone ...");
      cchar * color_tip = ZTX("White Balance, Color Profile, Color Matching");
      cchar * bend_tip = ZTX("Fix Perspective, Bend/Warp image ...");
      cchar * effects_tip = ZTX("Special Effects, Arty Transforms");
      cchar * combine_tip = ZTX("HDR, HDF, Panorama, Stack, Mashup");
      cchar * plugins_tip = ZTX("Use other image editors within Fotoxx");
      cchar * help_tip = ZTX("Quick Start, User Guide, Recent Changes ...");

      Vmenu_add(fvbm,0, "favorites.png", favorites_tip, m_favorites, 0 );
      Vmenu_add(fvbm,ZTX("File"), 0, file_tip, (mtFunc *) popup_menu, (cchar *) mFile);
      Vmenu_add(fvbm,ZTX("Tools"), 0, tools_tip, (mtFunc *) popup_menu, (cchar *) mTools);
      Vmenu_add(fvbm,ZTX("Metadata"), 0, metadata_tip, (mtFunc *) popup_menu, (cchar *) mMeta);
      Vmenu_add(fvbm,ZTX("Areas"), 0, areas_tip, (mtFunc *) popup_menu, (cchar *) mArea);
      Vmenu_add(fvbm,ZTX("Image"), 0, image_tip, (mtFunc *) popup_menu, (cchar *) mImage);
      Vmenu_add(fvbm,ZTX("Retouch"), 0, retouch_tip, (mtFunc *) popup_menu, (cchar *) mRet);
      Vmenu_add(fvbm,ZTX("Repair"), 0, repair_tip, (mtFunc *) popup_menu, (cchar *) mRep);
      Vmenu_add(fvbm,ZTX("Color"), 0, color_tip, (mtFunc *) popup_menu, (cchar *) mColor);
      Vmenu_add(fvbm,ZTX("Bend"), 0, bend_tip, (mtFunc *) popup_menu, (cchar *) mBend);
      Vmenu_add(fvbm,ZTX("Effects"), 0, effects_tip, (mtFunc *) popup_menu, (cchar *) mEff);
      Vmenu_add(fvbm,ZTX("Combine"), 0, combine_tip, (mtFunc *) popup_menu, (cchar *) mComb);
      Vmenu_add(fvbm,ZTX("Plugins"), 0, plugins_tip, (mtFunc *) popup_menu, (cchar *) mPlug);
      Vmenu_add(fvbm,ZTX("Help"), 0, help_tip, (mtFunc *) popup_menu, (cchar *) mHelp);
      Vmenu_add(fvbm," ---- ", 0, 0, 0, 0);
   }

   //  build a table of menu and toolbar items

   #define MENUENT(topmenu2,text2,icon2,desc2,func2,arg2)         \
   {  me = Nmenus++;                                              \
      menutab[me].topmenu = topmenu2;                             \
      menutab[me].menu = text2;                                   \
      menutab[me].icon = icon2;                                   \
      menutab[me].desc = desc2;                                   \
      menutab[me].func = func2;                                   \
      if (arg2) menutab[me].arg = arg2;                           \
      else menutab[me].arg = text2;  }

   int      me;
   Nmenus = 0;                                                             
  
   MENUENT(mFile,    ZTX("New Window"), 0,            ZTX("Open another window"),               m_clone, 0 );
   MENUENT(mFile,    ZTX("Open Image File"), 0,       ZTX("Open a new image file"),             m_open, 0 );
   MENUENT(mFile,    ZTX("Open Previous File"), 0,    ZTX("Open the previously seen file"),     m_previous, 0 );
   MENUENT(mFile,    ZTX("Recently Seen Images"), 0,  ZTX("Open a recently seen file"),         m_recentfiles, 0 );
   MENUENT(mFile,    ZTX("Newly Added Images"), 0,    ZTX("Open a newly added file"),           m_newfiles, 0 );
   MENUENT(mFile,    ZTX("Open RAW file (ufraw)"), 0, ZTX("Open and edit a camera RAW file"),   m_ufraw, 0 );
   MENUENT(mFile,    ZTX("Save to Disk"), 0,          ZTX("Save modified image file to disk"),  m_file_save, 0 );
   MENUENT(mFile,    ZTX("Rename Image File"), 0,     ZTX("Change the image file name"),        m_rename, 0 );
   MENUENT(mFile,    ZTX("New Blank Image"), 0,       ZTX("Create a blank image"),              m_create, 0 );
   MENUENT(mFile,    ZTX("Trash Image File"), 0,      ZTX("Move image file to Trash"),          m_trash, 0 );
   MENUENT(mFile,    ZTX("Print Image"), 0,           ZTX("Print the current image"),           m_print, 0 );
   MENUENT(mFile,    ZTX("Quit Fotoxx"), 0,           ZTX("Quit Fotoxx"),                       m_quit, 0 );

   MENUENT(mTools,   ZTX("Synchronize Files"), 0,         ZTX("Index new files and make thumbnails"),    m_syncfiles, 0 );
   MENUENT(mTools,   ZTX("User Settings"), 0,             ZTX("Change user preferences"),                m_settings, 0 );
   MENUENT(mTools,   ZTX("Keyboard Shortcuts"), 0,        ZTX("Change Keyboard Shortcut Keys"),          m_KBshortcuts, 0 );
   MENUENT(mTools,   ZTX("Manage Collections"), 0,        ZTX("Organize images into collections"),       m_manage_coll, 0 );
   MENUENT(mTools,   ZTX("Move Collections"), 0,          ZTX("Convert for a new top directory"),        m_move_coll, 0 );
   MENUENT(mTools,   ZTX("Slide Show"), 0,                ZTX("Start a slide show"),                     m_slideshow, 0 );
   MENUENT(mTools,   ZTX("Batch Rename"), 0,              ZTX("Rename multiple image files"),            m_batch_rename, 0 );
   MENUENT(mTools,   ZTX("Batch Convert/Resize/Move"), 0, ZTX("Convert resize, move multiple files"),    m_batch_convert, 0 );
   MENUENT(mTools,   ZTX("Batch Convert RAW Files"), 0,   ZTX("Convert multiple camera RAW files"),      m_batch_conv_raw, 0 );
   MENUENT(mTools,   ZTX("Brightness Distribution"), 0,   ZTX("Show a brightness distribution graph"),   m_histogram, 0 );
   MENUENT(mTools,   ZTX("Grid Lines"), 0,                ZTX("Show or revise grid lines"),              m_gridlines, 0 );
   MENUENT(mTools,   ZTX("Show RGB"), 0,                  ZTX("Show RGB colors at mouse click"),         m_show_RGB, 0 );
   MENUENT(mTools,   ZTX("Monitor Color"), 0,             ZTX("Chart to adjust monitor color"),          m_moncheck, 0 );
   MENUENT(mTools,   ZTX("Monitor Gamma"), 0,             ZTX("Chart to adjust monitor gamma"),          m_mongamma, 0 );
   MENUENT(mTools,   ZTX("Change Language"), 0,           ZTX("Change the GUI language"),                m_lang, 0 );
   MENUENT(mTools,   ZTX("Missing Translations"), 0,      ZTX("Report missing translations"),            m_untranslated, 0 );
   MENUENT(mTools,   ZTX("Edit Translations"), 0,         ZTX("Edit translations while using Fotoxx"),   m_translate, 0 );
   MENUENT(mTools,   ZTX("Menu and Launcher"), 0,         ZTX("Create a Gnome menu and launcher"),       m_menu_launcher, 0 );
   MENUENT(mTools,   ZTX("Burn Images to CD/DVD"), 0,     ZTX("Burn selected image files to CD or DVD"), m_burn, 0 );
   MENUENT(mTools,   ZTX("Resources"), 0,                 ZTX("Memory and CPU (to terminal/logfile)"),   m_resources, 0 );

   MENUENT(mMeta,    ZTX("Edit Metadata"), 0,           ZTX("Edit image tags/caption/rating ..."),     m_edit_metadata, 0 );
   MENUENT(mMeta,    ZTX("Batch Add/Remove Tags"), 0,   ZTX("Add/remove tags for multiple images"),    m_batchTags, 0 );
   MENUENT(mMeta,    ZTX("View Metadata (short)"), 0,   ZTX("List a few key metadata items"),          m_meta_view_short, 0 );
   MENUENT(mMeta,    ZTX("View Metadata (long)"), 0,    ZTX("List all metadata items"),                m_meta_view_long, 0 );
   MENUENT(mMeta,    ZTX("Edit Any Metadata"), 0,       ZTX("Edit any image metadata"),                m_meta_edit_any, 0 );
   MENUENT(mMeta,    ZTX("Delete Metadata"), 0,         ZTX("Remove all metadata from an image"),      m_meta_delete, 0 );
   MENUENT(mMeta,    ZTX("Download Geolocations"), 0,   ZTX("Download initial geolocation database"),  m_download_geolocs, 0 );
///MENUENT(mMeta,    ZTX("World Map Test"), 0,          ZTX("Test World Map coordinate transforms"),   m_worldmap_test, 0 );
   MENUENT(mMeta,    ZTX("Edit Geotags"), 0,            ZTX("Edit image location and geotags"),        m_edit_geotags, 0 );
   MENUENT(mMeta,    ZTX("Batch Add Geotags"), 0,       ZTX("Add geotags to multiple images"),         m_batch_add_geotags, 0 );
   MENUENT(mMeta,    ZTX("Images by Location/Date"), 0, ZTX("Find all images for a location [date]"),  m_geotag_groups, 0 );
   MENUENT(mMeta,    ZTX("Images by Map Location"), 0,  ZTX("Find images by clicking a world map"),    m_geotag_worldmap, 0 );
   MENUENT(mMeta,    ZTX("Search Images"), 0,           ZTX("Find images meeting select criteria"),    m_search_images, 0 );

   MENUENT(mArea,    ZTX("Select"), 0,     ZTX("Select object or area for editing"),     m_select, 0 );
   MENUENT(mArea,    ZTX("Show"), 0,       ZTX("Show (outline) existing area"),          m_select_show, 0 );
   MENUENT(mArea,    ZTX("Hide"), 0,       ZTX("Hide existing area"),                    m_select_hide, 0 );
   MENUENT(mArea,    ZTX("Enable"), 0,     ZTX("Enable area for editing"),               m_select_enable, 0 );
   MENUENT(mArea,    ZTX("Disable"), 0,    ZTX("Disable area for editing"),              m_select_disable, 0 );
   MENUENT(mArea,    ZTX("Invert"), 0,     ZTX("Reverse existing area"),                 m_select_invert, 0 );
   MENUENT(mArea,    ZTX("Unselect"), 0,   ZTX("Erase existing area"),                   m_select_unselect, 0 );
   MENUENT(mArea,    ZTX("Copy"), 0,       ZTX("Copy an area for later pasting"),        m_select_copy, 0 );
   MENUENT(mArea,    ZTX("Paste"), 0,      ZTX("Paste an area into the current image"),  m_select_paste, 0 );
   MENUENT(mArea,    ZTX("Open"), 0,       ZTX("Open a file with a saved area"),         m_select_open, 0 );
   MENUENT(mArea,    ZTX("Save"), 0,       ZTX("Save an area to a file"),                m_select_save, 0 );

   MENUENT(mImage,   ZTX("Rotate 90º"), 0,      ZTX("Rotate 90 degrees"),                          m_rotate90, 0 );
   MENUENT(mImage,   ZTX("Rotate"), 0,          ZTX("Rotate by any angle"),                        m_rotate, 0 );
   MENUENT(mImage,   ZTX("Trim/Crop"), 0,       ZTX("Cut off unwanted margins"),                   m_trim, 0 );
   MENUENT(mImage,   ZTX("Auto-Trim"), 0,       ZTX("Remove margins from warp, panorama, etc."),   m_autotrim, 0 );
   MENUENT(mImage,   ZTX("Resize"), 0,          ZTX("Change pixel dimensions"),                    m_resize, 0 );
   MENUENT(mImage,   ZTX("Flip"), 0,            ZTX("Mirror image horizontally or vertically"),    m_flip, 0 );
   MENUENT(mImage,   ZTX("Add Text"), 0,        ZTX("Write text on image"),                        m_write_text, 0 );

   MENUENT(mRet,  ZTX("Voodoo Enhance"), 0,             ZTX("Fast auto enhance that may work OK"),        m_voodoo, 0 );
   MENUENT(mRet,  ZTX("Brightness/Contrast/Color"), 0,  ZTX("Adjust brightness, contrast, color"),        m_brightcolor, 0 );  
   MENUENT(mRet,  ZTX("Gamma Curves"), 0,               ZTX("Adjust contrast using a gamma curve"),       m_gamma, 0 );
   MENUENT(mRet,  ZTX("Tone Mapping"), 0,               ZTX("Add local contrast, enhance details"),       m_tonemap, 0 );
   MENUENT(mRet,  ZTX("Flatten Brightness"), 0,         ZTX("Flatten brightness distribution"),           m_flatten, 0 );
   MENUENT(mRet,  ZTX("Expand Brightness"), 0,          ZTX("Expand brightness range"),                   m_xbrange, 0 );
   MENUENT(mRet,  ZTX("Brightness Ramp"), 0,            ZTX("Fix brightness uniformity across image"),    m_brightramp, 0 );
   MENUENT(mRet,  ZTX("Paint Edits"), 0,                ZTX("Paint edit function gradually with mouse"),  m_paint_edits, 0 );
   MENUENT(mRet,  ZTX("Leverage Edits"), 0,             ZTX("Leverage edits by brightness or color"),     m_lever_edits, 0 );

   MENUENT(mRep,     ZTX("Sharpen"), 0,            ZTX("Make the image look sharper"),                   m_sharpen, 0 );
   MENUENT(mRep,     ZTX("Blur"), 0,               ZTX("Make the image look fuzzy"),                     m_blur, 0 );
   MENUENT(mRep,     ZTX("Reduce Noise"), 0,       ZTX("Filter noise from low-light photos"),            m_denoise, 0 );
   MENUENT(mRep,     ZTX("Smart Erase"), 0,        ZTX("Remove unwanted objects"),                       m_smart_erase, 0 );
   MENUENT(mRep,     ZTX("Red Eyes"), 0,           ZTX("Fix red-eyes from electronic flash"),            m_redeye, 0 );
   MENUENT(mRep,     ZTX("Paint/Clone"), 0,        ZTX("Paint image pixels using the mouse"),            m_paint_clone, 0 );
   MENUENT(mRep,     ZTX("Remove Dust"), 0,        ZTX("Remove dust spots from scanned slides"),         m_dust, 0 );
   MENUENT(mRep,     ZTX("Anti-alias"), 0,         ZTX("Smoothen edges with jaggies"),                   m_antialias, 0 );
   MENUENT(mRep,     ZTX("Fix Color Fringes"), 0,  ZTX("Reduce Chromatic Abberation"),                   m_chromatic, 0 );
   MENUENT(mRep,     ZTX("Fix Stuck Pixels"), 0,   ZTX("Erase known hot and dark pixels"),               m_stuckpix, 0 );

   MENUENT(mColor,   ZTX("White Balance"), 0,      ZTX("Click on a white/gray area to fix color tint"),  m_whitebal, 0 );
   MENUENT(mColor,   ZTX("Color Mode"), 0,         ZTX("Make BW/color, negative/positive, sepia"),       m_colormode, 0 );
   MENUENT(mColor,   ZTX("Color Profile"), 0,      ZTX("Convert to another color profile"),              m_colorprof, 0 );
   MENUENT(mColor,   ZTX("Match Colors"), 0,       ZTX("Match colors on one image with another"),        m_match_color, 0 );
   MENUENT(mColor,   ZTX("Revise RGB"), 0,         ZTX("Adjust color in selected image areas"),          m_revise_RGB, 0 );
   MENUENT(mColor,   ZTX("CMYK Density"), 0,       ZTX("Adjust color using CMYK or RGB values"),         m_CMYK, 0 );

   MENUENT(mBend,    ZTX("Unbend"), 0,                ZTX("Remove curvature, esp. panoramas"),         m_unbend, 0 );
   MENUENT(mBend,    ZTX("Keystone Correction"), 0,   ZTX("Straighten objects seen from an angle"),    m_keystone, 0 );
   MENUENT(mBend,    ZTX("Flatten Book Page"), 0,     ZTX("Flatten a photographed book page"),         m_flatbook, 0 );
   MENUENT(mBend,    ZTX("Warp area"), 0,             ZTX("Distort image areas using the mouse"),      m_warp_area, 0 );
   MENUENT(mBend,    ZTX("Warp curved"), 0,           ZTX("Distort the whole image using the mouse"),  m_warp_curved, 0 );
   MENUENT(mBend,    ZTX("Warp linear"), 0,           ZTX("Distort the whole image using the mouse"),  m_warp_linear, 0 );
   MENUENT(mBend,    ZTX("Warp affine"), 0,           ZTX("Distort the whole image using the mouse"),  m_warp_affine, 0 );

   MENUENT(mEff,     ZTX("Color Depth"), 0,     ZTX("Reduce color depth (posterize)"),                m_colordep, 0 );
   MENUENT(mEff,     ZTX("Sketch"), 0,          ZTX("Convert to pencil sketch"),                      m_sketch, 0 );
   MENUENT(mEff,     ZTX("Drawing"), 0,         ZTX("Convert to colored line drawing"),               m_drawing, 0 );
   MENUENT(mEff,     ZTX("Graduated Blur"), 0,  ZTX("Graduated Blur depending on contrast"),          m_gradblur, 0 );
   MENUENT(mEff,     ZTX("Embossing"), 0,       ZTX("Create an embossed or 3D appearance"),           m_emboss, 0 );
   MENUENT(mEff,     ZTX("Tiles"), 0,           ZTX("Convert to square tiles"),                       m_tiles, 0 );
   MENUENT(mEff,     ZTX("Dots"), 0,            ZTX("Convert to dots (Roy Lichtenstein effect)"),     m_dots, 0 );
   MENUENT(mEff,     ZTX("Painting"), 0,        ZTX("Convert into a simulated painting"),             m_painting, 0 );
   MENUENT(mEff,     ZTX("False Colors"), 0,    ZTX("Shift/convert colors into other colors"),        m_false_color, 0 );
   MENUENT(mEff,     ZTX("Vignette"), 0,        ZTX("Change brightness or color radially"),           m_vignette, 0 );

   MENUENT(mComb,    ZTX("High Dynamic Range"), 0,  ZTX("Combine bright/dark images for better detail"),   m_HDR, 0 );
   MENUENT(mComb,    ZTX("High Depth of Field"), 0, ZTX("Combine near/far focus images for deeper focus"), m_HDF, 0 );
   MENUENT(mComb,    ZTX("Stack / Paint"), 0,       ZTX("Combine images to erase passing people, etc."),   m_STP, 0 );
   MENUENT(mComb,    ZTX("Stack / Noise"), 0,       ZTX("Combine noisy images into a low-noise image"),    m_STN, 0 );
   MENUENT(mComb,    ZTX("Panorama"), 0,            ZTX("Combine images into a panorama"),                 m_pano, 0 );
   MENUENT(mComb,    ZTX("Vertical Panorama"), 0,   ZTX("Combine images into a vertical panorama"),        m_vpano, 0 );
   MENUENT(mComb,    ZTX("Mashup"), 0,              ZTX("Arrange multiple images on a background image"),  m_mashup, 0 );

   MENUENT(mPlug,    ZTX("Edit Plugins"), 0, ZTX("Add another image editor to the menu"), m_edit_plugins, 0);

   MENUENT(mHelp,    ZTX("Quick Start"), 0,            ZTX("Quick Start mini-guide"),                 m_help, 0 );
   MENUENT(mHelp,    ZTX("User Guide"), 0,             ZTX("Read the user guide"),                    m_help, 0 );
   MENUENT(mHelp,    ZTX("User Guide Changes"), 0,     ZTX("Recent user guide changes"),              m_help, 0 );
   MENUENT(mHelp,    ZTX("Program Updates"), 0,        ZTX("Fotoxx updates notification"),            m_help, 0 );
   MENUENT(mHelp,    ZTX("Edit Functions Summary"), 0, ZTX("Summary of image edit functions"),        m_help, 0 );
   MENUENT(mHelp,    ZTX("README"), 0,                 ZTX("Technical installation notes"),           m_help, 0 );
   MENUENT(mHelp,    ZTX("Change Log"), 0,             ZTX("List updates by Fotoxx version"),         m_help, 0 );
   MENUENT(mHelp,    ZTX("Log File"), 0,               ZTX("View the log file and error messages"),   m_help, 0 );
   MENUENT(mHelp,    ZTX("Translations"), 0,           ZTX("How to do Fotoxx translations"),          m_help, 0 );
   MENUENT(mHelp,    ZTX("Home Page"), 0,              ZTX("Show the Fotoxx web page"),               m_help, 0 );
   MENUENT(mHelp,    ZTX("About"), 0,                  ZTX("Version, license, contact, credits"),     m_help, 0 );

   if (strEqu(menu_style,"classic"))
      MENUENT(fTbar, ZTX("Favs"),      "favorites.png",  ZTX("Favorites Menu"),                       m_favorites, 0 );

   MENUENT(fTbar,    ZTX("Color"),     "fg-color.png",   ZTX("Color of area borders etc."),           m_fg_color, 0 );
   MENUENT(fTbar,    ZTX("Undo"),      "undo.png",       ZTX("Undo one edit"),                        m_undo, 0 );
   MENUENT(fTbar,    ZTX("Redo"),      "redo.png",       ZTX("Redo one edit"),                        m_redo, 0 );
   MENUENT(fTbar,        "separator",  null,             null,                                        null, 0 );
   MENUENT(fTbar,    ZTX("Sync.G"),    "sync.G.png",     ZTX("Set gallery from current image file"),  navi::menufuncx, 0 );
   MENUENT(fTbar,    ZTX("Open"),      "open.png",       ZTX("Open a new image file"),                m_open, 0 );
   MENUENT(fTbar,    ZTX("Prev"),      "prev.png",       ZTX("Open the previous file"),               m_prev, 0 );
   MENUENT(fTbar,    ZTX("Next"),      "next.png",       ZTX("Open the next file"),                   m_next, 0 );
   MENUENT(fTbar,    ZTX("Save"),      "save.png",       ZTX("Save modified image file to disk"),     m_file_save, 0 );
   MENUENT(fTbar,    ZTX("Trash"),     "trash.png",      ZTX("Move image file to Trash"),             m_trash, 0 );


   if (strEqu(menu_style,"classic"))                                       //  build classic menu and toolbar
   {
      for (me = 0; me < Nmenus; me++)
      {
         if (menutab[me].topmenu == KBshort) continue;                     //  omit KB shortcut "menus"  v.13.04
         if (menutab[me].topmenu == fTbar)
            add_toolbar_button(fTbar, menutab[me].menu, menutab[me].desc, menutab[me].icon, menutab[me].func);
         else
            add_submenu_item(menutab[me].topmenu, menutab[me].menu, menutab[me].func, menutab[me].desc);
      }

      for (int ii = 0; ii < Nplugins; ii++)                                //  add plugin menu items
      {
         char *pp = strstr(plugins[ii]," = ");
         if (! pp) continue;
         *pp = 0;
         add_submenu_item(mPlug, plugins[ii], m_run_plugin, ZTX("Run as Fotoxx edit function"));
         *pp = ' ';
      }
   }

   else                                                                    //  build vertical menu and toolbar
   {
      for (me = 0; me < Nmenus; me++)
      {
         if (strEqu(menutab[me].menu,"separator")) continue;               //  separators not used
         if (menutab[me].topmenu == KBshort) continue;                     //  omit KB shortcut "menus"  v.13.04

         if (menutab[me].topmenu)
            add_popmenu_item(menutab[me].topmenu, menutab[me].menu,        //  submenu within top menu 
                   menutab[me].func, menutab[me].arg, menutab[me].desc);
         else {                                                            //  toolbar button
            if (strEqu(tbar_style,"text"))
               Vmenu_add(fvbm, menutab[me].menu, 0, menutab[me].desc, menutab[me].func, menutab[me].arg);
            else if (strEqu(tbar_style,"icons")) 
               Vmenu_add(fvbm, 0, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
            else 
               Vmenu_add(fvbm, menutab[me].menu, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
         }
      }

      for (int ii = 0; ii < Nplugins; ii++) {                              //  build plugins menu
         char *pp = strstr(plugins[ii]," = ");
         if (! pp) continue;
         *pp = 0;
         add_popmenu_item(mPlug, plugins[ii], m_run_plugin, 0, ZTX("Run as Fotoxx edit function"));  
         *pp = ' ';
      }
   }
   

   //  build the gallery window toolbar, either classic (at the top of the window)
   //   or vertical on the left side of the window.
   
   GtkWidget   *gTbar, *gVbox2, *ghbox;
   Vmenu       *gvbm = 0;
   PangoFontDescription    *pfontdesc;

   if (strEqu(menu_style,"classic"))                                       //  classic toolbar
   {
      gTbar = create_toolbar(gVbox,24);                                    //  add toolbar and buttons
      gVbox2 = gVbox;

      if (strEqu(tbar_style,"icons"))                                      //  set toolbar style
         gtk_toolbar_set_style(GTK_TOOLBAR(gTbar),GTK_TOOLBAR_ICONS);
      else if (strEqu(tbar_style,"text"))
         gtk_toolbar_set_style(GTK_TOOLBAR(gTbar),GTK_TOOLBAR_TEXT);
      else gtk_toolbar_set_style(GTK_TOOLBAR(gTbar),GTK_TOOLBAR_BOTH);
   }

   else                                                                    //  vertical toolbar
   {
      ghbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL,0);                   //   ____________________
      gtk_box_pack_start(GTK_BOX(gVbox),ghbox,1,1,0);                      //  |       |            |
      gTbar = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                     //  | gTbar |  gVbox2    | ghbox
      gVbox2 = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                    //  |       |  gallery   |
      gtk_box_pack_start(GTK_BOX(ghbox),gTbar,0,0,0);                      //  |_______|____________|
      gtk_box_pack_start(GTK_BOX(ghbox),gVbox2,1,1,0);
      gtk_widget_set_size_request(gTbar,10,10);                            //  compensate GTK bug
      gvbm = Vmenu_new(gTbar);
   }

   gHbox = gtk_box_new(HORIZONTAL,0);                                      //  add navigation widgets
   gtk_box_pack_start(GTK_BOX(gVbox2),gHbox,0,0,0);                        //  [Top] [no directory]
   gTop = gtk_button_new_with_label(ZTX("Top"));
   gPath = gtk_entry_new();                                                //  add directory label
   gtk_entry_set_text(GTK_ENTRY(gPath),"no directory");
   gtk_widget_set_can_focus(gPath,0);                                      //  stop unwanted focus
   gtk_box_pack_start(GTK_BOX(gHbox),gTop,0,0,3);
   gtk_box_pack_start(GTK_BOX(gHbox),gPath,1,1,3);
   pfontdesc = pango_font_description_from_string("Monospace 10");         //  monospace font, 8 pixel width
   gtk_widget_modify_font(gPath,pfontdesc);

   gSwin = gtk_scrolled_window_new(0,0);                                   //  create scrolled window
   gtk_scrolled_window_set_policy(SCROLLWIN(gSwin),ALWAYS,ALWAYS);         //  vertical scroll bar       v.13.02
   gSadj = gtk_scrolled_window_get_vadjustment(SCROLLWIN(gSwin));
   gtk_box_pack_start(GTK_BOX(gVbox2),gSwin,1,1,0);
   gDwin = gtk_drawing_area_new();                                         //  create drawing window
   gtk_scrolled_window_add_with_viewport(SCROLLWIN(gSwin),gDwin);          //  add to scrolled window

   int me0 = Nmenus;

   MENUENT(gTbar, ZTX("Sync.G"),  "sync.G.png",   ZTX("Set gallery from current image file"),   navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Open"),    "open.png",     ZTX("open another directory"),                navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("GoTo"),    "goto.png",     ZTX("go to bookmarked image"),                navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Zoom+"),   "zoom+.png",    ZTX("increase thumbnail size"),               navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Zoom-"),   "zoom-.png",    ZTX("reduce thumbnail size"),                 navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Sort"),    "sort.png",     ZTX("change sort order"),                     navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("First"),   "top.png",      ZTX("jump to beginning (top)"),               navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Last"),    "bottom.png",   ZTX("jump to end (bottom)"),                  navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Page↑"),   "up+.png",      ZTX("previous page"),                         navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Page↓"),   "down+.png",    ZTX("next page"),                             navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Row↑"),    "up.png",       ZTX("previous row"),                          navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Row↓"),    "down.png",     ZTX("next row"),                              navi::menufuncx, 0 );

   for (me = me0; me < Nmenus; me++)
   {
      if (strEqu(menu_style,"classic"))
         add_toolbar_button(gTbar, menutab[me].menu, menutab[me].desc, menutab[me].icon, menutab[me].func);
      else {
         if (strEqu(tbar_style,"text"))
            Vmenu_add(gvbm, menutab[me].menu, 0, menutab[me].desc, menutab[me].func, menutab[me].arg);
         else if (strEqu(tbar_style,"icons")) 
            Vmenu_add(gvbm, 0, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
         else 
            Vmenu_add(gvbm, menutab[me].menu, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
      }
   }

   return;
}


/**************************************************************************/

//  Setup function for right-click popup menus
//  for the main window and gallery thumbnails.

GtkWidget  *popmenu_main, *popmenu_thumb, *popmenu_coll_thumb, *popmenu_raw;

void Rclick_Popup_setup()
{
   static int        initflag = 0;
   
   if (initflag && ! ZTXnewtranslations()) return;                         //  v.13.01
   initflag = 1;

   cchar    *menurename = ZTX("Rename");
   cchar    *menucopytoloc = ZTX("Copy to Location");
   cchar    *menumovetoloc = ZTX("Move to Location");
   cchar    *menutrash = ZTX("Trash");
   cchar    *menudelete = ZTX("Delete");
   cchar    *menucopytoclip = ZTX("Copy to Clipboard");
   cchar    *menuremovefromcoll = ZTX("Remove from Collection");
   cchar    *menucuttocache = ZTX("Cut to Image Cache");
   cchar    *menucopytocache = ZTX("Copy to Image Cache");
   cchar    *menupastecachehere = ZTX("Paste Image Cache Here (clear)");
   cchar    *menupastecachekeep = ZTX("Paste Image Cache Here (keep)");
   cchar    *menutrim = ZTX("Trim/Crop");
   cchar    *menuresize = ZTX("Resize");
   cchar    *menuturn = ZTX("Rotate 90º");
   cchar    *menuvoodoo = ZTX("Voodoo Enhance");
   cchar    *menubright = ZTX("Brightness/Color");
   cchar    *menugamma = ZTX("Gamma Curves");
   cchar    *menuflatten = ZTX("Flatten Brightness");
   cchar    *menutonemap = ZTX("Tone Mapping");
   cchar    *menuwhitebal = ZTX("White Balance");
   cchar    *menuredeyes = ZTX("Red Eyes");
   cchar    *menugrid = ZTX("Grid Lines");
   cchar    *menuselect = ZTX("Select Area");
   cchar    *menuopenraw = ZTX("Open RAW file (ufraw)");

   popmenu_main = create_popmenu();                                        //  main window image
   add_popmenu_item(popmenu_main,menurename,popup_menufunc,"rename");
   add_popmenu_item(popmenu_main,menucopytoloc,popup_menufunc,"copytoloc");
   add_popmenu_item(popmenu_main,menumovetoloc,popup_menufunc,"movetoloc");
   add_popmenu_item(popmenu_main,menudelete,popup_menufunc,"delete");
   add_popmenu_item(popmenu_main,menutrash,popup_menufunc,"trash");
   add_popmenu_item(popmenu_main,menutrim,popup_menufunc,"trim");
   add_popmenu_item(popmenu_main,menuresize,popup_menufunc,"resize");
   add_popmenu_item(popmenu_main,menuturn,popup_menufunc,"rotate 90º");
   add_popmenu_item(popmenu_main,menuvoodoo,popup_menufunc,"voodoo");
   add_popmenu_item(popmenu_main,menubright,popup_menufunc,"bright");
   add_popmenu_item(popmenu_main,menugamma,popup_menufunc,"gamma");
   add_popmenu_item(popmenu_main,menuflatten,popup_menufunc,"flatten");
   add_popmenu_item(popmenu_main,menutonemap,popup_menufunc,"tonemap");
   add_popmenu_item(popmenu_main,menuwhitebal,popup_menufunc,"whitebal");
   add_popmenu_item(popmenu_main,menuredeyes,popup_menufunc,"redeyes");
   add_popmenu_item(popmenu_main,menugrid,popup_menufunc,"grid");
   add_popmenu_item(popmenu_main,menuselect,popup_menufunc,"select");
   add_popmenu_item(popmenu_main,menucopytoclip,popup_menufunc,"copytoclip");

   popmenu_thumb = create_popmenu();                                       //  gallery thumbnail
   add_popmenu_item(popmenu_thumb,menurename,popup_menufunc,"rename");
   add_popmenu_item(popmenu_thumb,menucopytoloc,popup_menufunc,"copytoloc");
   add_popmenu_item(popmenu_thumb,menumovetoloc,popup_menufunc,"movetoloc");
   add_popmenu_item(popmenu_thumb,menutrash,popup_menufunc,"trash");
   add_popmenu_item(popmenu_thumb,menudelete,popup_menufunc,"delete");
   add_popmenu_item(popmenu_thumb,menucopytocache,popup_menufunc,"copytocache");
   add_popmenu_item(popmenu_thumb,menucopytoclip,popup_menufunc,"copytoclip");

   popmenu_raw = create_popmenu();                                         //  gallery thumbnail, RAW file
   add_popmenu_item(popmenu_raw,menuopenraw,f_open_ufraw,0);
   add_popmenu_item(popmenu_raw,menurename,popup_menufunc,"rename");
   add_popmenu_item(popmenu_raw,menucopytoloc,popup_menufunc,"copytoloc");
   add_popmenu_item(popmenu_raw,menumovetoloc,popup_menufunc,"movetoloc");
   add_popmenu_item(popmenu_raw,menutrash,popup_menufunc,"trash");
   add_popmenu_item(popmenu_raw,menudelete,popup_menufunc,"delete");

   popmenu_coll_thumb = create_popmenu();                                  //  gallery thumbnail (collection)
   add_popmenu_item(popmenu_coll_thumb,menuremovefromcoll,popup_menufunc,"removefromcoll");
   add_popmenu_item(popmenu_coll_thumb,menucuttocache,popup_menufunc,"cuttocache");
   add_popmenu_item(popmenu_coll_thumb,menucopytocache,popup_menufunc,"copytocache");
   add_popmenu_item(popmenu_coll_thumb,menupastecachehere,popup_menufunc,"pastecachehere");
   add_popmenu_item(popmenu_coll_thumb,menupastecachekeep,popup_menufunc,"pastecachekeep");
   add_popmenu_item(popmenu_coll_thumb,menucopytoclip,popup_menufunc,"copytoclip");
   
   return;
}   


//  right-click popup menu function

void popup_menufunc(GtkWidget *, cchar *menu)                              //  v.12.12
{
   if (strEqu(menu,"rename")) m_rename(0,0);                               //  funcs used from main + gallery windows
   if (strEqu(menu,"copytoloc")) m_copytoloc(0,0);                         //  these funcs use clicked_file if defined,
   if (strEqu(menu,"movetoloc")) m_movetoloc(0,0);                         //    else they use curr_file.
   if (strEqu(menu,"delete")) m_delete(0,0);                               //  set clicked_file to null after use.
   if (strEqu(menu,"trash")) m_trash(0,0);
   if (strEqu(menu,"copytoclip")) copyto_clip(0,0);

   if (strEqu(menu,"removefromcoll")) coll_popup_remove(0,0);              //  funcs used from collection gallery 
   if (strEqu(menu,"cuttocache")) coll_popup_cutfile(0,0);                 //  depend on clicked_file being defined
   if (strEqu(menu,"copytocache")) coll_popup_copyfile(0,0);               //  set clicked_file to null after use
   if (strEqu(menu,"pastecachehere")) coll_popup_pastecache(0,"clear");
   if (strEqu(menu,"pastecachekeep")) coll_popup_pastecache(0,"keep");

   if (strEqu(menu,"trim")) m_trim(0,0);                                   //  these functions use curr_file only
   if (strEqu(menu,"resize")) m_resize(0,0);                               //  (not used for gallery/thumbnail click)
   if (strEqu(menu,"rotate 90º")) m_rotate90(0,0);
   if (strEqu(menu,"voodoo")) m_voodoo(0,0);
   if (strEqu(menu,"bright")) m_brightcolor(0,0);
   if (strEqu(menu,"gamma")) m_gamma(0,0);
   if (strEqu(menu,"flatten")) m_flatten(0,0);
   if (strEqu(menu,"tonemap")) m_tonemap(0,0);
   if (strEqu(menu,"whitebal")) m_whitebal(0,0);
   if (strEqu(menu,"redeyes")) m_redeye(0,0);
   if (strEqu(menu,"grid")) toggle_grid(2);
   if (strEqu(menu,"select")) m_select(0,0);

   return;
}


//  main window mouse right-click popup menu

void image_Rclick_popup(int Nth)
{
   Rclick_Popup_setup();
   if (! curr_file) return;
   popup_menu(0,popmenu_main);
   return;
}


//  gallery thumbnail mouse left-click function
//  open the clicked file in tab F

void gallery_Lclick_func(int Nth)
{
   char     *file;

   F1_help_topic = "navigation";
   
   file = gallery(0,"find",Nth);
   if (! file) return;
   f_open(file,1,Nth,0,1);                                                 //  clicked file >> current file
   zfree(file);
   settab("F");
   return;
}


//  gallery thumbnail mouse right-click popup menu

void gallery_Rclick_popup(int Nth)                                         //  v.13.07
{
   int      ftyp;

   Rclick_Popup_setup();

   clicked_posn = Nth;                                                     //  clicked gallery position (0 base)
   clicked_file = gallery(0,"find",Nth);                                   //  clicked_file is subject for zfree()
   if (! clicked_file) return;
   ftyp = image_file_type(clicked_file);
   
   if (navi::gallerytype == 4)                                             //  gallery type is collection
      popup_menu(0,popmenu_coll_thumb);
   
   else if (ftyp == 2)                                                     //  clicked thumbnail is an image file
      popup_menu(0,popmenu_thumb);

   else if (ftyp == 3)                                                     //  clicked thumbnail is a RAW file
      popup_menu(0,popmenu_raw);

   return;
}



